"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _innerSpinner = _interopRequireDefault(require("./innerSpinner"));

var _outerSpinner = _interopRequireDefault(require("./outerSpinner"));

var _View = _interopRequireDefault(require("react-native-web/dist/cjs/exports/View"));

var _Animated = _interopRequireDefault(require("react-native-web/dist/cjs/exports/Animated"));

var _Easing = _interopRequireDefault(require("react-native-web/dist/cjs/exports/Easing"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var LoadingSpinner =
/*#__PURE__*/
function (_React$Component) {
  _inherits(LoadingSpinner, _React$Component);

  function LoadingSpinner() {
    var _this;

    _classCallCheck(this, LoadingSpinner);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(LoadingSpinner).call(this));
    _this.spinValue = new _Animated.default.Value(0);
    return _this;
  }

  _createClass(LoadingSpinner, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.spin();
    }
  }, {
    key: "render",
    value: function render() {
      var spin = this.spinValue.interpolate({
        inputRange: [0, 1],
        outputRange: ['0deg', '360deg']
      });
      var _this$props = this.props,
          size = _this$props.size,
          color = _this$props.color,
          colorOpacity = _this$props.colorOpacity,
          colorBackground = _this$props.colorBackground;
      return _react.default.createElement(_View.default, null, _react.default.createElement(_Animated.default.View, {
        style: {
          width: size,
          height: size,
          transform: [{
            rotate: spin
          }]
        }
      }, _react.default.createElement(_outerSpinner.default, {
        color: color,
        width: size,
        height: size
      })), _react.default.createElement(_innerSpinner.default, {
        color: color,
        colorBackground: colorBackground,
        colorOpacity: colorOpacity,
        width: size,
        height: size
      }));
    }
  }, {
    key: "spin",
    value: function spin() {
      var _this2 = this;

      this.spinValue.setValue(0);

      _Animated.default.timing(this.spinValue, {
        toValue: 1,
        duration: 7000,
        easing: _Easing.default.linear
      }).start(function () {
        return _this2.spin();
      });
    }
  }]);

  return LoadingSpinner;
}(_react.default.Component);

exports.default = LoadingSpinner;
LoadingSpinner.propTypes = {
  /** Width and height of the */
  size: _propTypes.default.number.isRequired,

  /** Specifies color of vector graphic*/
  color: _propTypes.default.string,

  /** Specifies the secondary color of vector graphic*/
  colorOpacity: _propTypes.default.string,

  /** Specifies the background color of vector graphic*/
  colorBackground: _propTypes.default.string
};